#include "StdAfx.h"
#include "ImageViewerWrapper.h"

HMODULE CImageViewerWrapper::s_hModule = NULL;
FnShowViewer CImageViewerWrapper::s_ShowViewer = NULL;
FnInitViewer CImageViewerWrapper::s_InitViewer = NULL;
FnInitParam   CImageViewerWrapper::s_InitParam  = NULL;

CImageViewerWrapper::CImageViewerWrapper(void)
{
}

CImageViewerWrapper::~CImageViewerWrapper(void)
{
}

int CImageViewerWrapper::Init(const wchar_t* authInfo, int showInTaskbar)
{
	if (s_InitViewer == NULL || s_ShowViewer == NULL || s_InitParam == NULL)
	{
		wstring wcsDllPath = GetCurrentPath() + _T("ImageViewer.dll");
		s_hModule = LoadLibraryW(wcsDllPath.c_str());
		DWORD dRet = GetLastError();
		s_InitViewer = (FnInitViewer)GetProcAddress(s_hModule, "InitViewer");
		s_ShowViewer = (FnShowViewer)GetProcAddress(s_hModule, "ShowViewer");
		s_InitParam  = (FnInitParam)GetProcAddress(s_hModule, "InitParam");
		if (s_InitViewer == NULL || s_ShowViewer == NULL || s_InitParam == NULL)
		{
			return -1;
		}
	}
	
	int nRet = s_InitViewer(authInfo, showInTaskbar);

	return nRet;
}

int CImageViewerWrapper::Show(const wchar_t* imagePaths, int currPos)
{
	return s_ShowViewer(imagePaths, currPos);
}

int CImageViewerWrapper::InitParam(int flag, UINT_PTR flagvalue)
{
	return s_InitParam(flag, flagvalue);
}


string UnicodeToUtf8OrAnsi(const WCHAR * lpszStr, UINT codePage)
{
	CHAR * lpStringRet;
	int nLen;

	string strRet;
	if (NULL == lpszStr)
		return "";

	nLen = ::WideCharToMultiByte(codePage, 0, lpszStr, -1, NULL, 0, NULL, NULL);
	if (0 == nLen)
		return NULL;

	lpStringRet = new CHAR[nLen + 1];
	if (NULL == lpStringRet)
		return "";

	memset(lpStringRet, 0, nLen + 1);
	nLen = ::WideCharToMultiByte(codePage, 0, lpszStr, -1, lpStringRet, nLen, NULL, NULL);
	if (0 == nLen)
	{
		strRet = "";
	}
	else
	{
		strRet = lpStringRet;
	}

	delete []lpStringRet;
	return strRet;
}

wstring& trim(wstring& text, const wchar_t* Regex)
{  
	if(!text.empty())  
	{  
		if (Regex == NULL)
		{
			text.erase(0, text.find_first_not_of(_T(" \n\r\t")));  
			text.erase(text.find_last_not_of(_T(" \n\r\t")) + 1);  
		}
		else
		{
			text.erase(0, text.find_first_not_of(Regex));  
			text.erase(text.find_last_not_of(Regex) + 1);  
		}
	}  
	return text;  
}

wstring GetCurrentPath()
{
	WCHAR wcsPath[MAX_PATH] = {0};
	GetModuleFileNameW(NULL, wcsPath, MAX_PATH);
	wstring strPath = wcsPath;
	int nPos = strPath.rfind(L'\\');
	strPath = strPath.substr(0, nPos + 1);
	return strPath;
}
